#!/bin/sh
# $Id: t-tlsr-cnf-0.sh,v 1.3 2007/06/13 04:43:08 ca Exp $
#

# ---------------------------
# run t-tlsr-cnf-0 with some configuration files
# ---------------------------

test -s stop && exit 1              

PRG=t-tlsr-cnf-0
IN=${PRG}.in
OUT=${PRG}.out
OK=${PRG}.ok

TEST=1
rm -f ${IN} ${OUT} ${OK}
cat > ${IN} <<EOF
cert_issuer="/C=US/ST=California/L=Emeryville/O=Example+20Org/OU=MTA/CN=CA/emailAddress=CA@example.org"; min_cipher_bits=590;requirements_violation=permfail;
EOF
cat > ${OK} <<EOF
CN=(null)
CS=(null)
CI=/C=US/ST=California/L=Emeryville/O=Example+20Org/OU=MTA/CN=CA/emailAddress=CA@example.org
flags=0
bits=590
requirements_violation=permfail
EOF
./${PRG} ${IN} 2>&1 | grep -v tests > ${OUT}
if grep MTA_USE_TLS ${OUT} >/dev/null
then
  exit 0
fi
if diff ${OUT} ${OK}
then
  :
else
  echo "$0: FAIL: test ${TEST}"
  exit 1
fi


TEST=2
rm -f ${IN} ${OUT} ${OK}
cat > ${IN} <<EOF
cert_issuer="/C=US/ST=California/L=Emeryville/O=Example+20Org/OU=MTA/CN=CA/emailAddress=CA@example.org"; min_cipher_bits=90;flags={verified};
EOF
cat > ${OK} <<EOF
CN=(null)
CS=(null)
CI=/C=US/ST=California/L=Emeryville/O=Example+20Org/OU=MTA/CN=CA/emailAddress=CA@example.org
flags=0x1
bits=90
requirements_violation=abort
EOF
./${PRG} ${IN} 2>&1 | grep -v tests > ${OUT}
if diff ${OUT} ${OK}
then
  :
else
  echo "$0: FAIL: test ${TEST}"
  exit 1
fi

rm -f ${IN} ${OUT} ${OK}
exit 0
